/***********************************************************

 Copyright Derrick Stolee 2011.

 This file is part of SearchLib.

 SearchLib is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 SearchLib is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with SearchLib.  If not, see <http://www.gnu.org/licenses/>.

 *************************************************************/

/*
 * chains.cpp
 *
 *  Created on: Jun 22, 2011
 *      Author: derrickstolee
 */
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "ChainManager.hpp"

int main(int argc, char** argv)
{
	ChainManager* manager = 0;

	int k = 0; /* k = number of crossings */
	int j = 0; /* j = formula number */
	int minN = 0; /* minimum number to care about */
	int maxN = 0; /* maximum number to care about */
	int a = 0; /* maximum value to consider at each position */
	int maxSum = 0; /* maximum sum to consider over all positions */
	int interval = 10000; /* lengths of intervals to check for numbers */

	for ( int i = 1; i < argc; i++ )
	{
		if ( argv[i][0] == '-' && i < argc - 1 )
		{
			switch ( argv[i][1] )
			{
			case 'K':
				k = atoi(argv[i + 1]);
				break;

			case 'J':
				j = atoi(argv[i + 1]);
				break;

			case 'n':
				minN = atoi(argv[i + 1]);
				break;

			case 'N':
				maxN = atoi(argv[i + 1]);
				break;

			case 'a':
				a = atoi(argv[i + 1]);
				break;

			case 'S':
				maxSum = atoi(argv[i + 1]);
				break;

			case '-':
				if ( strcmp(argv[i], "--interval") == 0 )
				{
					interval = atoi(argv[i + 1]);
				}

				break;

			default:
				break;
			}
		}
	}


	manager = new ChainManager(k, j, minN, maxN, a, maxSum, interval);

	manager->importArguments(argc, argv);

	while ( manager->readJob(stdin) >= 0 )
	{
		manager->doSearch();
	}

	delete manager;

	return 0;
}

